Index: squid/src/Plaxton.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/Plaxton.c,v
retrieving revision 1.1.2.1
retrieving revision 1.1.2.2
diff -u -r1.1.2.1 -r1.1.2.2
--- squid/src/Plaxton.c	20 Nov 2001 06:59:14 -0000	1.1.2.1
+++ squid/src/Plaxton.c	21 May 2002 02:46:42 -0000	1.1.2.2
@@ -1206,30 +1200,31 @@
 static void
 removeNodeParentList(struct sockaddr_in *goneNode)
 {
-  int index;
-  NodeKey n, *current;
-  struct sockaddr_in s1, s2;
-
-  NodeKey_Init(&n, goneNode);
-
-  index = parentListIndex(&n);
-
-
-  LIST_FORALL2(&parentListA[index], NodeKey *, current){
-    if(!NodeKey_Compare(&n, current)){
-      List_Remove((List_Links *)current);
-      xfree(current);
-      return;
-    }
-    /*
-     * Check invariant that list is sorted by distance from me.
-     */
-    if((List_Links *)current != LIST_ATREAR(&parentListA[index])){
-      s1 = NodeKey_GetAddr(current);
-      s2 = NodeKey_GetAddr((NodeKey *)List_Next((List_Links *)current));
-      assert(HCHier_compareDistanceFromMe(s1.sin_addr, s2.sin_addr) <= 0);
+    int index;
+    dlink_node *node;
+    HintCacheNodeKey n, *current;
+    struct sockaddr_in s1, s2;
+
+    hintCacheNodeKeyInit(&n, goneNode);
+
+    index = parentListIndex(&n);
+
+    for (node = parentListA[index]; node; node = node->next) {
+	current = node->data;
+	if (!hintCacheNodeKeyCompare(&n, current)) {
+	    dlinkDelete(node, &parentListA[index]);
+	    xfree(current);
+	    return;
+	}
+	/*
+	 * Check invariant that list is sorted by distance from me.
+	 */
+	if ((dlink_node *) current != LIST_ATREAR(&parentListA[index])) {
+	    s1 = hintCacheNodeKeyGetAddr(current);
+	    s2 = hintCacheNodeKeyGetAddr((HintCacheNodeKey *) List_Next((dlink_node *) current));
+	    assert(hintCacheHierCompareDistanceFromMe(s1.sin_addr, s2.sin_addr) <= 0);
+	}
     }
-  }
 }
 
 /*
@@ -1258,8 +1253,8 @@
 static void
 changeDistanceParentList(struct sockaddr_in *changeDistNode)
 {
-  removeNodeParentList(changeDistNode);
-  addNodeParentList(changeDistNode);
+    removeNodeParentList(changeDistNode);
+    addNodeParentList(changeDistNode);
 }
 
 
@@ -1283,9 +1278,9 @@
  *----------------------------------------------------4.19.1998------
  */
 static int
-parentListIndex(NodeKey *n)
+parentListIndex(HintCacheNodeKey * n)
 {
-  return fullMatchIndex(n->key);
+    return fullMatchIndex(n->key);
 }
 
 /*
@@ -1308,23 +1303,24 @@
  *-----------------------------------------------------4.19.1998------
  */
 static int
-fullMatchIndex(GenericKey k)
+fullMatchIndex(HintCacheKey k)
 {
-  int bits, levelsThatMatch, indexInBucket, index;
-  
-  bits = plaxtonMatchBits(k, myNodeKey);
-  if(bits == nParentLevels * bitsPerLevel){
-      /* 
-       * I am root! want to match in all bits in last level 
-       * This will force system to get right indexInBucket in 
-       * last level.
-       */
-      bits--;
-  }
-  levelsThatMatch = bits / bitsPerLevel;
-  indexInBucket = (k >> (levelsThatMatch * bitsPerLevel)) % Plaxton_bucketsPerLevel;
-  index = firstLevelBucketForMatch(bits) + indexInBucket;
-  return index;
+    int bits, levelsThatMatch, indexInBucket, index;
+
+    bits = plaxtonMatchBits(k, myNodeKey);
+    if (bits == nParentLevels * bitsPerLevel) {
+	/* 
+	 * I am root! want to match in all bits in last level 
+	 * This will force system to get right indexInBucket in 
+	 * last level.
+	 */
+	bits--;
+    }
+    levelsThatMatch = bits / bitsPerLevel;
+    indexInBucket =
+	(k >> (levelsThatMatch * bitsPerLevel)) % Plaxton_bucketsPerLevel;
+    index = firstLevelBucketForMatch(bits) + indexInBucket;
+    return index;
 }
 
 
@@ -1352,19 +1348,19 @@
 static void
 addNodeHighestMatch(struct sockaddr_in *addNode)
 {
-  NodeKey n;
-  int match, imatch;
+    HintCacheNodeKey n;
+    int match, imatch;
 
-  NodeKey_Init(&n, addNode);
+    hintCacheNodeKeyInit(&n, addNode);
 
-  match = plaxtonMatchBits(n.key, myNodeKey);
-  if(match == BITS_PER_KEY){
-      match--;
-  }
-  for(imatch = 0; imatch <= match; imatch++){
-    matchInsert(&highestMatchA[imatch], addNode);
-  }
-  return;
+    match = plaxtonMatchBits(n.key, myNodeKey);
+    if (match == BITS_PER_KEY) {
+	match--;
+    }
+    for (imatch = 0; imatch <= match; imatch++) {
+	matchInsert(&highestMatchA[imatch], addNode);
+    }
+    return;
 }
 
 /*
@@ -1386,30 +1382,35 @@
  *-------------------------------------------------------4.16.1998----
  */
 static void
-matchInsert(List_Links *l, struct sockaddr_in *a)
+matchInsert(dlink_list *l, struct sockaddr_in *a)
 {
-  NodeKey *current, *n;
+    HintCacheNodeKey *current, *n;
+    dlink_node *node;
 
+    n = (HintCacheNodeKey *) xmalloc(sizeof(HintCacheNodeKey));
+    assert(n);
+    hintCacheNodeKeyInit(n, a);
+
+    /*
+     * Each list always contains at least me.
+     */
+    assert(l->head != 0);
 
-  n = (NodeKey *)xmalloc(sizeof(NodeKey));
-  assert(n);
-  NodeKey_Init(n, a);
-
-  /*
-   * Each list always contains at least me.
-   */
-  assert(!List_IsEmpty(l));
-
-  LIST_FORALL2(l, NodeKey *, current){
-    assert(current->key != n->key);
-    if(current->key < n->key){
-      List_Insert((List_Links *)n, LIST_BEFORE((List_Links *)current));
-      return;
-    }
-  }
-  assert(((NodeKey *)List_Last(l))->key >= n->key);
-  List_Insert((List_Links *)n, LIST_ATREAR((l)));
-  return;
+    for (node = l->head; node; node = node->next) {
+	current = node->data;
+	assert(current->key != n->key);
+	if (current->key < n->key) {
+	    /* Put 'n' right before 'current' */
+	    n->next = current;
+	    n->prev = current->prev;
+	    current->prev = current;
+	    n->prev->next = n;
+	    return;
+	}
+    }
+    assert(((HintCacheNodeKey *) l->tail->data)->key >= n->key);
+    dlinkAddTail(n, &n->links, l);
+    return;
 }
 
 /*
@@ -1434,19 +1435,19 @@
 static void
 removeNodeHighestMatch(struct sockaddr_in *goneNode)
 {
-  NodeKey n;
-  int match, imatch;
+    HintCacheNodeKey n;
+    int match, imatch;
 
-  NodeKey_Init(&n, goneNode);
+    hintCacheNodeKeyInit(&n, goneNode);
 
-  match = plaxtonMatchBits(n.key, myNodeKey);
-  if(match == BITS_PER_KEY){
-      match --;
-  }
-  for(imatch = 0; imatch <= match; imatch++){
-    matchRemove(&highestMatchA[imatch], goneNode);
-  }
-  return;
+    match = plaxtonMatchBits(n.key, myNodeKey);
+    if (match == BITS_PER_KEY) {
+	match--;
+    }
+    for (imatch = 0; imatch <= match; imatch++) {
+	matchRemove(&highestMatchA[imatch], goneNode);
+    }
+    return;
 }
 
 /*
@@ -1468,24 +1469,26 @@
  *--------------------------------------------------4.16.1998-----------
  */
 static void
-matchRemove(List_Links *l, struct sockaddr_in *a)
+matchRemove(dlink_llist *list, struct sockaddr_in *a)
 {
-  NodeKey *current, n;
+    HintCacheNodeKey *current, n;
+    dlink_node *node;
+
+    hintCacheNodeKeyInit(&n, a);
+    /*
+     * Each list always contains at least me.
+     */
+    assert(list->head != 0);
 
-  NodeKey_Init(&n, a);
-  /*
-   * Each list always contains at least me.
-   */
-  assert(!List_IsEmpty(l));
-
-  LIST_FORALL2(l, NodeKey *, current){
-    if(!NodeKey_Compare(current, &n)){
-      List_Remove((List_Links *)current);
-      xfree(current);
-      return;
+    for (node = list->head; node; node = node->next) {
+	current = node->data;
+	if (!hintCacheNodeKeyCompare(current, &n)) {
+	    dlinkDelete(node, list);
+	    xfree(current);
+	    return;
+	}
     }
-  }
-  return;
+    return;
 }
 
 /*
@@ -1507,24 +1510,24 @@
  *
  *------------------------------------------------------------------
  */
-int 
+int
 plaxtonCheckIfParent(URLKey key, struct sockaddr_in *candidate)
 {
-  int index, amIRoot;
-  struct sockaddr_in real;
+    int index, amIRoot;
+    struct sockaddr_in real;
 
-  assert(initialized);
-  index = plaxtonParentQIndex(&key, &amIRoot);
-  if(amIRoot){
-    return 0;
-  }
-  if(plaxtonGetParentAddr(index, &real)){
+    assert(initialized);
+    index = plaxtonParentQIndex(&key, &amIRoot);
+    if (amIRoot) {
+	return 0;
+    }
+    if (plaxtonGetParentAddr(index, &real)) {
+	return 0;
+    }
+    if (candidate->sin_addr.s_addr == real.sin_addr.s_addr) {
+	return 1;
+    }
     return 0;
-  }
-  if(candidate->sin_addr.s_addr == real.sin_addr.s_addr){
-    return 1;
-  }
-  return 0;
 }
 
 
@@ -1551,17 +1554,17 @@
  *------------------------------------------------4.9.1998----------
  */
 static void
-childAdd(NodeKey *key)
+childAdd(HintCacheNodeKey * key)
 {
-  int l;
+    int l;
 
-  l = plaxtonMatchBits(key->key, myNodeKey);
-  assert(l <= nChildLists);
-  List_Insert((List_Links*)key, LIST_ATFRONT(&childrenListA[l]));
-  childrenCountA[l]++;
-  childrenCountTot++;
-  assert(childFind(key));
-  return;
+    l = plaxtonMatchBits(key->key, myNodeKey);
+    assert(l <= nChildLists);
+    dlinkAdd(key, &key->links, childrenListA[l]);
+    childrenCountA[l]++;
+    childrenCountTot++;
+    assert(childFind(key));
+    return;
 }
 
 /*
@@ -1582,20 +1585,22 @@
  *
  *-------------------------------------------------4.9.1998---------
  */
-static NodeKey *
-childFind(NodeKey *key)
+static HintCacheNodeKey *
+childFind(HintCacheNodeKey * key)
 {
-  int l;
-  NodeKey *current;
-
-  l = plaxtonMatchBits(key->key, myNodeKey);
-  assert(l <= nChildLists);
-  LIST_FORALL2(&childrenListA[l], NodeKey *, current){
-    if(!NodeKey_Compare(current, key)){
-      return current;
+    HintCacheNodeKey *current;
+    dlink_node *node;
+    int l;
+
+    l = plaxtonMatchBits(key->key, myNodeKey);
+    assert(l <= nChildLists);
+    for (node = childrenListA[l].head; node ; node = node->next) {
+	current = node->data;
+	if (!hintCacheNodeKeyCompare(current, key)) {
+	    return current;
+	}
     }
-  }
-  return NULL;
+    return NULL;
 }
 
 
@@ -1619,19 +1624,17 @@
  *-----------------------------------------------------4.10.1998-------
  */
 int
-plaxtonMatchBits(GenericKey k1, GenericKey k2)
+plaxtonMatchBits(HintCacheKey k1, HintCacheKey k2)
 {
-  int ibit;
-  GenericKey mask;
-  
-  for(ibit = 0, mask = 0x1; 
-      ibit < nChildLists - 1; 
-      ibit++, mask = mask << 1){
-    if((k1 & mask) != (k2 & mask)){
-      return ibit;
+    int ibit;
+    HintCacheKey mask;
+
+    for (ibit = 0, mask = 0x1; ibit < nChildLists - 1; ibit++, mask = mask << 1) {
+	if ((k1 & mask) != (k2 & mask)) {
+	    return ibit;
+	}
     }
-  }
-  return ibit;
+    return ibit;
 }
 
 
@@ -1653,10 +1656,10 @@
  *
  *------------------------------------------------------------------
  */
-GenericKey 
+HintCacheKey
 plaxtonmyNodeKey(void)
 {
-  return myNodeKey;
+    return myNodeKey;
 }
 
 
@@ -1683,21 +1686,26 @@
 void
 plaxtonSelfTest()
 {
-  printf("plaxtonSelfTest..."); fflush(stdout);
-  testMakeMatchKey();
-  neighborsOutgoing = (HCNet *)xmalloc(sizeof(HCNet));
-  assert(neighborsOutgoing);
-  printf("."); fflush(stdout);
-  HCNet_Init(neighborsOutgoing);
-  HCNet_SetTestMode(neighborsOutgoing);
-  selfTestChildren();
-  printf("."); fflush(stdout);
-  selfTestParents();
-  printf("."); fflush(stdout);
-  HCNet_Destroy(neighborsOutgoing);
-  xfree(neighborsOutgoing);
-  printf(".Done.\n"); fflush(stdout);
-  return;
+    printf("plaxtonSelfTest...");
+    fflush(stdout);
+    testMakeMatchKey();
+    neighborsOutgoing = (HCNet *) xmalloc(sizeof(HCNet));
+    assert(neighborsOutgoing);
+    printf(".");
+    fflush(stdout);
+    HCNet_Init(neighborsOutgoing);
+    HCNet_SetTestMode(neighborsOutgoing);
+    selfTestChildren();
+    printf(".");
+    fflush(stdout);
+    selfTestParents();
+    printf(".");
+    fflush(stdout);
+    HCNet_Destroy(neighborsOutgoing);
+    xfree(neighborsOutgoing);
+    printf(".Done.\n");
+    fflush(stdout);
+    return;
 }
 
 /*
@@ -1721,101 +1729,111 @@
 static void
 selfTestChildren()
 {
-  int iaddr;
-  struct sockaddr_in n0;
-  static int CHECK_ADDR_BEGIN = 1000;
-  static int CHECK_ADDR_END = 2000;
-  static int CHECK_NOT_THERE_END = 3000;
-  static URLKey urlMatchAll, urlMatchNone, urlMatchOne, urlMatchEight;
-  int amILeaf = -1;
-  int childCount, allChildren;
-  struct sockaddr_in *childrenA = NULL;
-
-  assert(CHECK_ADDR_END > CHECK_ADDR_BEGIN);
-  assert(CHECK_ADDR_END < CHECK_NOT_THERE_END);
-
-
-
-  allChildren = CHECK_ADDR_END - CHECK_ADDR_BEGIN;
-  plaxtonInit(8);
-
-  assert(sizeof(URLKey) == sizeof(GenericKey)); /* bypassing normal init */
-  urlMatchAll.key = myNodeKey;
-  urlMatchNone.key = ~myNodeKey;
-  urlMatchOne.key = (~myNodeKey) ^ 0x1;
-  urlMatchEight.key = (~myNodeKey) ^ 0xFF;
-
-  assert(plaxtonNChildrenQs() == sizeof(GenericKey) * 8 + 1);
-  amILeaf = -1;
-  assert(plaxtonChildQIndex(&urlMatchAll, 0, &amILeaf) == sizeof(GenericKey) * 8);
-  assert(amILeaf == 1);
-  amILeaf = -1;
-  assert(plaxtonChildQIndex(&urlMatchNone, 0, &amILeaf) == 0);
-  assert(amILeaf == 1);
-  amILeaf = -1;
-  assert(plaxtonChildQIndex(&urlMatchOne, 0, &amILeaf) == 1);
-  assert(amILeaf == 1);
-  amILeaf = -1;
-  assert(plaxtonChildQIndex(&urlMatchEight, 0, &amILeaf) == 8);
-  assert(amILeaf == 1);
-  childrenA = (struct sockaddr_in *)0x888888;
-  childCount = plaxtonGetChildAddrs(15, &childrenA);
-  assert(childCount == 0);
-  assert(childrenA == NULL);
-
-  for(iaddr = CHECK_ADDR_BEGIN; iaddr < CHECK_ADDR_END; iaddr++){
-    n0.sin_addr.s_addr = iaddr; n0.sin_port = 0;
-    plaxtonAddChild(&n0);
-  }
-
-  childCount = plaxtonGetChildAddrs(sizeof(GenericKey) * 8, &childrenA);
-  assert(childCount == allChildren);
-  assert(childrenA != NULL);
-  assert(selfTestFindAddr(CHECK_ADDR_BEGIN, childrenA, childCount));
-  assert(selfTestFindAddr((CHECK_ADDR_BEGIN + CHECK_ADDR_END) / 2, 
-		   childrenA, childCount));
-  assert(selfTestFindAddr(CHECK_ADDR_END - 1, childrenA, childCount));
-  assert(!selfTestFindAddr(CHECK_ADDR_END, childrenA, childCount));
-  xfree(childrenA);
-
-  /*
-   * The nodes we inserted as children were random. Assuming 
-   * we inserted a reasonable number of them, it would be
-   * surprizing if more than, say, 60% matched us in the
-   * lowest bit or if fewer than, say, 40% match us in the
-   * lowest bit
-   */
-  if(allChildren >= 1000){
-    childCount = plaxtonGetChildAddrs(0, &childrenA);
-    if(allChildren * 0.6  < childCount){
-      printf("WARNING WARNING WARNING WARNING\n");
-      printf("WARNING: Plaxton saw unlikely distribution of random children.\n");
-      printf("WARNING: (too many). This is very nearly an assertion failure.\n");
-    }
-    if(allChildren * 0.4 > childCount){
-      printf("WARNING WARNING WARNING WARNING\n");
-      printf("WARNING: Plaxton saw unlikely distribution of random children.\n");
-      printf("WARNING: (too few). This is very nearly an assertion failure.\n");
-    }
+    int iaddr;
+    struct sockaddr_in n0;
+    static int CHECK_ADDR_BEGIN = 1000;
+    static int CHECK_ADDR_END = 2000;
+    static int CHECK_NOT_THERE_END = 3000;
+    static URLKey urlMatchAll, urlMatchNone, urlMatchOne, urlMatchEight;
+    int amILeaf = -1;
+    int childCount, allChildren;
+    struct sockaddr_in *childrenA = NULL;
+
+    assert(CHECK_ADDR_END > CHECK_ADDR_BEGIN);
+    assert(CHECK_ADDR_END < CHECK_NOT_THERE_END);
+
+
+
+    allChildren = CHECK_ADDR_END - CHECK_ADDR_BEGIN;
+    plaxtonInit(8);
+
+    assert(sizeof(URLKey) == sizeof(HintCacheKey));	/* bypassing normal init */
+    urlMatchAll.key = myNodeKey;
+    urlMatchNone.key = ~myNodeKey;
+    urlMatchOne.key = (~myNodeKey) ^ 0x1;
+    urlMatchEight.key = (~myNodeKey) ^ 0xFF;
+
+    assert(plaxtonNChildrenQs() == sizeof(HintCacheKey) * 8 + 1);
+    amILeaf = -1;
+    assert(plaxtonChildQIndex(&urlMatchAll, 0,
+	    &amILeaf) == sizeof(HintCacheKey) * 8);
+    assert(amILeaf == 1);
+    amILeaf = -1;
+    assert(plaxtonChildQIndex(&urlMatchNone, 0, &amILeaf) == 0);
+    assert(amILeaf == 1);
+    amILeaf = -1;
+    assert(plaxtonChildQIndex(&urlMatchOne, 0, &amILeaf) == 1);
+    assert(amILeaf == 1);
+    amILeaf = -1;
+    assert(plaxtonChildQIndex(&urlMatchEight, 0, &amILeaf) == 8);
+    assert(amILeaf == 1);
+    childrenA = (struct sockaddr_in *) 0x888888;
+    childCount = plaxtonGetChildAddrs(15, &childrenA);
+    assert(childCount == 0);
+    assert(childrenA == NULL);
+
+    for (iaddr = CHECK_ADDR_BEGIN; iaddr < CHECK_ADDR_END; iaddr++) {
+	n0.sin_addr.s_addr = iaddr;
+	n0.sin_port = 0;
+	plaxtonAddChild(&n0);
+    }
+
+    childCount = plaxtonGetChildAddrs(sizeof(HintCacheKey) * 8, &childrenA);
+    assert(childCount == allChildren);
+    assert(childrenA != NULL);
+    assert(selfTestFindAddr(CHECK_ADDR_BEGIN, childrenA, childCount));
+    assert(selfTestFindAddr((CHECK_ADDR_BEGIN + CHECK_ADDR_END) / 2,
+	    childrenA, childCount));
+    assert(selfTestFindAddr(CHECK_ADDR_END - 1, childrenA, childCount));
+    assert(!selfTestFindAddr(CHECK_ADDR_END, childrenA, childCount));
     xfree(childrenA);
-  }
-  else{
-    printf("\nWARNING: Plaxton selftest skipping random match check (too few samples\n");
-  }
-
-  printf(".");fflush(stdout);
-  for(iaddr = CHECK_ADDR_BEGIN; iaddr < CHECK_ADDR_END; iaddr++){
-    n0.sin_addr.s_addr = iaddr; n0.sin_port = 0;
-    assert(plaxtonCheckIfChild(&n0));
-    plaxtonRemoveChild(&n0);
-  }
-  printf(".");fflush(stdout);
-  for(iaddr = CHECK_ADDR_BEGIN; iaddr < CHECK_NOT_THERE_END; iaddr++){
-    n0.sin_addr.s_addr = iaddr; n0.sin_port = 0;
-    assert(!plaxtonCheckIfChild(&n0));
-  }
-  plaxtonDestroy();
-  printf(".OK\n");
+
+    /*
+     * The nodes we inserted as children were random. Assuming 
+     * we inserted a reasonable number of them, it would be
+     * surprizing if more than, say, 60% matched us in the
+     * lowest bit or if fewer than, say, 40% match us in the
+     * lowest bit
+     */
+    if (allChildren >= 1000) {
+	childCount = plaxtonGetChildAddrs(0, &childrenA);
+	if (allChildren * 0.6 < childCount) {
+	    printf("WARNING WARNING WARNING WARNING\n");
+	    printf
+		("WARNING: Plaxton saw unlikely distribution of random children.\n");
+	    printf
+		("WARNING: (too many). This is very nearly an assertion failure.\n");
+	}
+	if (allChildren * 0.4 > childCount) {
+	    printf("WARNING WARNING WARNING WARNING\n");
+	    printf
+		("WARNING: Plaxton saw unlikely distribution of random children.\n");
+	    printf
+		("WARNING: (too few). This is very nearly an assertion failure.\n");
+	}
+	xfree(childrenA);
+    } else {
+	printf
+	    ("\nWARNING: Plaxton selftest skipping random match check (too few samples\n");
+    }
+
+    printf(".");
+    fflush(stdout);
+    for (iaddr = CHECK_ADDR_BEGIN; iaddr < CHECK_ADDR_END; iaddr++) {
+	n0.sin_addr.s_addr = iaddr;
+	n0.sin_port = 0;
+	assert(plaxtonCheckIfChild(&n0));
+	plaxtonRemoveChild(&n0);
+    }
+    printf(".");
+    fflush(stdout);
+    for (iaddr = CHECK_ADDR_BEGIN; iaddr < CHECK_NOT_THERE_END; iaddr++) {
+	n0.sin_addr.s_addr = iaddr;
+	n0.sin_port = 0;
+	assert(!plaxtonCheckIfChild(&n0));
+    }
+    plaxtonDestroy();
+    printf(".OK\n");
 }
 
 
@@ -1842,18 +1860,19 @@
 static int
 selfTestFindAddr(int addr, struct sockaddr_in *childrenA, int childCount)
 {
-  struct sockaddr_in n0;
-  int ii;
+    struct sockaddr_in n0;
+    int ii;
 
-  assert(childrenA != NULL);
-  n0.sin_addr.s_addr = addr; n0.sin_port = 0;
-  for(ii = 0; ii < childCount; ii++){
-    assert(childrenA[ii].sin_port == 0);
-    if(childrenA[ii].sin_addr.s_addr == n0.sin_addr.s_addr){
-      return 1;
+    assert(childrenA != NULL);
+    n0.sin_addr.s_addr = addr;
+    n0.sin_port = 0;
+    for (ii = 0; ii < childCount; ii++) {
+	assert(childrenA[ii].sin_port == 0);
+	if (childrenA[ii].sin_addr.s_addr == n0.sin_addr.s_addr) {
+	    return 1;
+	}
     }
-  }
-  return 0;
+    return 0;
 }
 
 
@@ -1878,11 +1897,11 @@
 static void
 selfTestParents(void)
 {
-  testParentsBinaryTree();
-  testParentsMultiRootCase();
-  testParentsInternals();
-  testParentsInternals2();
-  stressTestParents();
+    testParentsBinaryTree();
+    testParentsMultiRootCase();
+    testParentsInternals();
+    testParentsInternals2();
+    stressTestParents();
 }
 
 /*
@@ -1907,120 +1926,119 @@
 static void
 testParentsBinaryTree(void)
 {
-  int myId, targetId, caseCount;
-  struct sockaddr_in parents[4], retAddr;
-  int ii, hops, qIndex, iAmRoot;
-  NodeKey key;
-  URLKey targetURLKey;
-
-  /* XXX Make sure that entire code merge happens. Funny little bug in
-   * tools.h that we fixed.
-   */
-  parents[0].sin_addr.s_addr = 10;
-  parents[0].sin_port = 0;
-  parents[1].sin_addr.s_addr = 11;
-  parents[1].sin_port = 0;
-  assert(SINCMP(&parents[0], &parents[1])); /* if this fails, bug in SINCMP */
-  
-  /*
-   * Try this test from every point of view
-   */
-  for(myId = 0; myId < 4; myId++){
-    plaxtonInit(1);
-    assert(plaxtonNParentQs() == 192);
+    int myId, targetId, caseCount;
+    struct sockaddr_in parents[4], retAddr;
+    int ii, hops, qIndex, iAmRoot;
+    HintCacheNodeKey key;
+    URLKey targetURLKey;
 
+    /* XXX Make sure that entire code merge happens. Funny little bug in
+     * tools.h that we fixed.
+     */
+    parents[0].sin_addr.s_addr = 10;
+    parents[0].sin_port = 0;
+    parents[1].sin_addr.s_addr = 11;
+    parents[1].sin_port = 0;
+    assert(SINCMP(&parents[0], &parents[1]));	/* if this fails, bug in SINCMP */
 
-    /* 
-     * Cheat to force my key to do right thing 
+    /*
+     * Try this test from every point of view
      */
-    myNodeKey = (GenericKey)myId;
-    for(ii = 0; ii < BITS_PER_KEY; ii++){
-      assert(!List_IsEmpty(&highestMatchA[ii]));
-      ((NodeKey *)List_First(&highestMatchA[ii]))->key = myNodeKey;
-    }
-
-    for(caseCount = 1; caseCount <= 3; caseCount++){
-      /*
-       * Do all combinations of bottom two bits except my own
-       */
-      targetId = myId ^ caseCount;
-      /* 
-       * Search for a node that matches desired bits
-       */
-      for(ii = 0; ; ii++){
-	parents[caseCount].sin_addr.s_addr =  myId * 1000 + ii; 
-	parents[caseCount].sin_port = 0;
-	NodeKey_Init(&key, &parents[caseCount]);
-	if((key.key & 0x3) == targetId){
-	  if(caseCount == 1){
-	    assert((key.key & 0x2) == (myNodeKey & 0x2));
-	    assert((key.key & 0x1) != (myNodeKey & 0x1));
-	    hops = 1;
-	  }
-	  else{
-	    assert((key.key & 0x2) != (myNodeKey & 0x2));
-	    hops = 2;
-	  }
-          HCHier_newNode(&parents[caseCount], hops, 999);
+    for (myId = 0; myId < 4; myId++) {
+	plaxtonInit(1);
+	assert(plaxtonNParentQs() == 192);
+	
 
-	  break;
+	/* 
+	 * Cheat to force my key to do right thing 
+	 */
+	myNodeKey = (HintCacheKey) myId;
+	for (ii = 0; ii < BITS_PER_KEY; ii++) {
+	    assert(highestMatchA[ii].head != 0);
+	    ((HintCacheNodeKey *) highestMatchA[ii].head->data)->key = myNodeKey;
+	}
+	
+	for (caseCount = 1; caseCount <= 3; caseCount++) {
+	    /*
+	     * Do all combinations of bottom two bits except my own
+	     */
+	    targetId = myId ^ caseCount;
+	    /* 
+	     * Search for a node that matches desired bits
+	     */
+	    for (ii = 0;; ii++) {
+		parents[caseCount].sin_addr.s_addr = myId * 1000 + ii;
+		parents[caseCount].sin_port = 0;
+		hintCacheNodeKeyInit(&key, &parents[caseCount]);
+		if ((key.key & 0x3) == targetId) {
+		    if (caseCount == 1) {
+			assert((key.key & 0x2) == (myNodeKey & 0x2));
+			assert((key.key & 0x1) != (myNodeKey & 0x1));
+			hops = 1;
+		    } else {
+			assert((key.key & 0x2) != (myNodeKey & 0x2));
+			hops = 2;
+		    }
+		    HCHier_newNode(&parents[caseCount], hops, 999);
+
+		    break;
+		}
+	    }
 	}
-      }
-    }
 
 
-    /*
-     * Case 0: same in all bits
-     */
-    targetURLKey.key = myId;
-    qIndex = plaxtonParentQIndex(&targetURLKey, &iAmRoot);
-    assert(iAmRoot);
+	/*
+	 * Case 0: same in all bits
+	 */
+	targetURLKey.key = myId;
+	qIndex = plaxtonParentQIndex(&targetURLKey, &iAmRoot);
+	assert(iAmRoot);
 
 
-    /*
-     * Case 1: differ in bit 0 --> queue is at level 0
-     * and the (key & 0x1)th queue within level 0
-     */
-    targetURLKey.key = myId ^ 0x1;
-    qIndex  = plaxtonParentQIndex(&targetURLKey, &iAmRoot);
-    assert(!iAmRoot);
-    assert(qIndex == ((unsigned)targetURLKey.key & 0x1));
-    assert(plaxtonGetParentAddr(qIndex, &retAddr) == 0);
-    assert(retAddr.sin_addr.s_addr == parents[1].sin_addr.s_addr);
-    assert(plaxtonCheckIfParent(targetURLKey, &parents[1]));
-    assert(!plaxtonCheckIfParent(targetURLKey, &parents[2]));
-    assert(!plaxtonCheckIfParent(targetURLKey, &parents[3]));
+	/*
+	 * Case 1: differ in bit 0 --> queue is at level 0
+	 * and the (key & 0x1)th queue within level 0
+	 */
+	targetURLKey.key = myId ^ 0x1;
+	qIndex = plaxtonParentQIndex(&targetURLKey, &iAmRoot);
+	assert(!iAmRoot);
+	assert(qIndex == ((unsigned) targetURLKey.key & 0x1));
+	assert(plaxtonGetParentAddr(qIndex, &retAddr) == 0);
+	assert(retAddr.sin_addr.s_addr == parents[1].sin_addr.s_addr);
+	assert(plaxtonCheckIfParent(targetURLKey, &parents[1]));
+	assert(!plaxtonCheckIfParent(targetURLKey, &parents[2]));
+	assert(!plaxtonCheckIfParent(targetURLKey, &parents[3]));
 
 
-    /*
-     * Case 2: differ in bit 1; same bit 0 --> queue is
-     * at level 1 and the (key & 0x1)the queue within level 1
-     */
-    targetURLKey.key = myId ^ 0x2;
-    qIndex  = plaxtonParentQIndex(&targetURLKey, &iAmRoot);
-    assert(!iAmRoot);
-    assert(qIndex == 2 + (((unsigned)targetURLKey.key & 0x2)>>1));
-    assert(plaxtonGetParentAddr(qIndex, &retAddr) == 0);
-    assert(retAddr.sin_addr.s_addr == parents[2].sin_addr.s_addr);
-    assert(!plaxtonCheckIfParent(targetURLKey, &parents[1]));
-    assert(plaxtonCheckIfParent(targetURLKey, &parents[2]));
-    assert(!plaxtonCheckIfParent(targetURLKey, &parents[3]));
+	/*
+	 * Case 2: differ in bit 1; same bit 0 --> queue is
+	 * at level 1 and the (key & 0x1)the queue within level 1
+	 */
+	targetURLKey.key = myId ^ 0x2;
+	qIndex = plaxtonParentQIndex(&targetURLKey, &iAmRoot);
+	assert(!iAmRoot);
+	assert(qIndex == 2 + (((unsigned) targetURLKey.key & 0x2) >> 1));
+	assert(plaxtonGetParentAddr(qIndex, &retAddr) == 0);
+	assert(retAddr.sin_addr.s_addr == parents[2].sin_addr.s_addr);
+	assert(!plaxtonCheckIfParent(targetURLKey, &parents[1]));
+	assert(plaxtonCheckIfParent(targetURLKey, &parents[2]));
+	assert(!plaxtonCheckIfParent(targetURLKey, &parents[3]));
 
-    /* 
-     * Case 3: differ in bits 0 and 1; should be same as case 1
-     */
-    targetURLKey.key = myId ^ 0x3;
-    qIndex  = plaxtonParentQIndex(&targetURLKey, &iAmRoot);
-    assert(!iAmRoot);
-    assert(qIndex == ((unsigned)targetURLKey.key & 0x1));
-    assert(plaxtonGetParentAddr(qIndex, &retAddr) == 0);
-    assert(retAddr.sin_addr.s_addr == parents[1].sin_addr.s_addr);
-    assert(plaxtonCheckIfParent(targetURLKey, &parents[1]));
-    assert(!plaxtonCheckIfParent(targetURLKey, &parents[2]));
-    assert(!plaxtonCheckIfParent(targetURLKey, &parents[3]));
-    
-    plaxtonDestroy();
-  }
+	/* 
+	 * Case 3: differ in bits 0 and 1; should be same as case 1
+	 */
+	targetURLKey.key = myId ^ 0x3;
+	qIndex = plaxtonParentQIndex(&targetURLKey, &iAmRoot);
+	assert(!iAmRoot);
+	assert(qIndex == ((unsigned) targetURLKey.key & 0x1));
+	assert(plaxtonGetParentAddr(qIndex, &retAddr) == 0);
+	assert(retAddr.sin_addr.s_addr == parents[1].sin_addr.s_addr);
+	assert(plaxtonCheckIfParent(targetURLKey, &parents[1]));
+	assert(!plaxtonCheckIfParent(targetURLKey, &parents[2]));
+	assert(!plaxtonCheckIfParent(targetURLKey, &parents[3]));
+
+	plaxtonDestroy();
+    }
 }
 
 /*
@@ -2047,66 +2065,65 @@
 static void
 testParentsMultiRootCase(void)
 {
-  int eligibleFound, ii;
-  struct sockaddr_in sin, maxAddr, retAddr;
-  static unsigned int nodeMask = 0xFF;
-  static unsigned int objMask = 0x3F;
-  GenericKey maxKey;
-  URLKey targetURLKey;
-  int qIndex, iAmRoot;
-  NodeKey anotherNodeKey;
-
-  plaxtonInit(2);
-
-  assert(objMask < nodeMask);
-  assert((objMask & nodeMask) == objMask);
-
-  /*
-   * Create a bunch of nodes that are eligible to be the root for
-   * for an object that matches them (and us) in objMask bits
-   * and mismatches in the next bit
-   */
-  /* XXX   targetURLKey.key = (myNodeKey & objMask) ^ (nodeMask ^ objMask);*/
-  targetURLKey.key = (myNodeKey & nodeMask) ^ (nodeMask ^ objMask);
-
-  qIndex = plaxtonParentQIndex(&targetURLKey, &iAmRoot);
-  assert(iAmRoot);
-
-  maxKey = myNodeKey;
-  maxAddr = Config.Sockaddr.http->s;
-  ii = 0;
-  eligibleFound = 0;
-  while(eligibleFound < 40){
-    sin.sin_addr.s_addr = 10000 + ii;
-    sin.sin_port = 0;
-    NodeKey_Init(&anotherNodeKey, &sin);
-    if((anotherNodeKey.key & nodeMask) == (myNodeKey & nodeMask)){
-      eligibleFound++;
-      HCHier_newNode(&sin, 1000, 999);
-      if(anotherNodeKey.key > maxKey){
-	/*
-	 * Found new root for object 
-	 */
-	maxKey = anotherNodeKey.key;
-	maxAddr = sin;
-      }
-    }
+    int eligibleFound, ii;
+    struct sockaddr_in sin, maxAddr, retAddr;
+    static unsigned int nodeMask = 0xFF;
+    static unsigned int objMask = 0x3F;
+    HintCacheKey maxKey;
+    URLKey targetURLKey;
+    int qIndex, iAmRoot;
+    HintCacheNodeKey anotherNodeKey;
+
+    plaxtonInit(2);
+
+    assert(objMask < nodeMask);
+    assert((objMask & nodeMask) == objMask);
+
+    /*
+     * Create a bunch of nodes that are eligible to be the root for
+     * for an object that matches them (and us) in objMask bits
+     * and mismatches in the next bit
+     */
+    /* XXX   targetURLKey.key = (myNodeKey & objMask) ^ (nodeMask ^ objMask); */
+    targetURLKey.key = (myNodeKey & nodeMask) ^ (nodeMask ^ objMask);
+
     qIndex = plaxtonParentQIndex(&targetURLKey, &iAmRoot);
-    if(maxKey == myNodeKey){
-      assert(iAmRoot);
-    }
-    if(iAmRoot){
-      assert(maxKey == myNodeKey);
+    assert(iAmRoot);
+
+    maxKey = myNodeKey;
+    maxAddr = Config.Sockaddr.http->s;
+    ii = 0;
+    eligibleFound = 0;
+    while (eligibleFound < 40) {
+	sin.sin_addr.s_addr = 10000 + ii;
+	sin.sin_port = 0;
+	hintCacheNodeKeyInit(&anotherNodeKey, &sin);
+	if ((anotherNodeKey.key & nodeMask) == (myNodeKey & nodeMask)) {
+	    eligibleFound++;
+	    HCHier_newNode(&sin, 1000, 999);
+	    if (anotherNodeKey.key > maxKey) {
+		/*
+		 * Found new root for object 
+		 */
+		maxKey = anotherNodeKey.key;
+		maxAddr = sin;
+	    }
+	}
+	qIndex = plaxtonParentQIndex(&targetURLKey, &iAmRoot);
+	if (maxKey == myNodeKey) {
+	    assert(iAmRoot);
+	}
+	if (iAmRoot) {
+	    assert(maxKey == myNodeKey);
+	} else {
+	    assert(plaxtonGetParentAddr(qIndex, &retAddr) == 0);
+	    assert(qIndex >= nParentLevels * plaxtonbucketsPerLevel);
+	    assert(retAddr.sin_addr.s_addr == maxAddr.sin_addr.s_addr);
+	}
+	ii++;
     }
-    else{
-      assert(plaxtonGetParentAddr(qIndex, &retAddr) == 0);
-      assert(qIndex >= nParentLevels * plaxtonbucketsPerLevel);
-      assert(retAddr.sin_addr.s_addr == maxAddr.sin_addr.s_addr);
-    }
-    ii++;
-  }
-  plaxtonDestroy();
-  
+    plaxtonDestroy();
+
 }
 
 
